// generic.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "generic.h"
#include "genericDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGenericApp

BEGIN_MESSAGE_MAP(CGenericApp, CWinApp)
	//{{AFX_MSG_MAP(CGenericApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CGenericApp construction

CGenericApp::CGenericApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CGenericApp object

CGenericApp theApp;


// PASSOLO START
/////////////////////////////////////////////////////////////////////////////
// ExpandWithExePath expand filename with exepath
BOOL CGenericApp::ExpandWithExePath(LPTSTR path, int npath)
{
    if (path[0] == _T('\\') || path[1] == _T(':'))
        return TRUE;

    TCHAR exepath[MAX_PATH];

    int n = ::GetModuleFileName(m_hInstance, exepath, DIMOF(exepath));

    if (n == 0)
        return FALSE;

    LPTSTR p = _tcsrchr(exepath, _T('\\'));

    if (p) p++;
    else   p = exepath;
    *p = (TCHAR) 0;

    n = lstrlen(exepath);

    if (n + (int) lstrlen(path) + 1 > npath)
        return FALSE;

    memmove(path + n, path, (lstrlen(path) + 1) * sizeof(TCHAR));
    memmove(path, exepath, n * sizeof(TCHAR));

    return TRUE;
}
// PASSOLO end


/////////////////////////////////////////////////////////////////////////////
// CGenericApp initialization

BOOL CGenericApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

    // PASSOLO start
    TCHAR inifile[MAX_PATH];
    TCHAR dllfile[MAX_PATH];

    _tcscpy( inifile, _T("rscpara.ini"));
    ExpandWithExePath( inifile, DIMOF(inifile));

    LCID locale;
    BOOL useDLL = GetPrivateProfileInt(_T("APPLICATION"),
                                       _T("UseDLL"), 0, inifile);
    if (useDLL)
    {
        // Sprach DLL laden als Applikation-Ressource eintragen.
        // Im Beispiel franzsisch
        GetPrivateProfileString(_T("APPLICATION"),_T("LangDLL"),_T(""),
                                dllfile, sizeof(dllfile), inifile);
        ExpandWithExePath( dllfile, DIMOF(dllfile));

        HINSTANCE hdll = LoadLibrary(dllfile);  
        AfxSetResourceHandle((hdll != NULL) ? hdll : AfxGetInstanceHandle());
    }
    else
    {
        // In Exe vorhanden: Englisch (9) und Deutsch (7)
        locale = (LCID) GetPrivateProfileInt(_T("APPLICATION"),
                                      _T("LangID"),LANG_ENGLISH, inifile);
        locale = MAKELCID(MAKELANGID(locale, 1), SORT_DEFAULT);

        SetThreadLocale(locale);
    }
    // PASSOLO end

    CGenericDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
